use uo;
use util;

include "include/classes";
include "include/hitscriptinc";


function ClassWeaponAttack(attacker, defender, )


var attackerweaponType := cfg[attacker.weapon.objtype];
var defenderweaponType := cfg[defender.weapon.objtype];

var attackerlevelmod := GetClasseSkillTotal(attacker, GetClass(attacker));

attackerlevelmod := CDbl(attackerlevelmod/8.0);

// Ambush Stuff
var ambushprop := GetObjProperty(attacker, "attackInitiatedWhileHidden");
var ambush  := 0;
if ((ambushprop > (ReadGameClock()-4)) && IsThief(attacker))
	ambush := 1;
endif
  

if (attacker.weapon.attribute == ATTRIBUTEID_ARCHERY)
	if (!checkForAndDecrementAmmunition( attacker, attackerweaponType))	
		return;
	endif

	if (! ValidArcheryWeapon(attackerweaponType))
		return;
	endif

	PlayArcheryAnimation(attacker, defender, attackerweaponType, ambush);
endif


PerformAction( attacker,attackerweaponType.Anim);
sleep((100-attackerweaponType.Speed)/10);
				
if (CheckHitChance(attacker, defender, attackerlevelmod))
	if (attacker.weapon.attribute == ATTRIBUTEID_ARCHERY)
		if (ambush)
       		 	PlaySoundEffect( defender, 0x145 );
      		else
        		PlaySoundEffect( defender, attackerweaponType.hitSound );
     	 	endif
	else
		if (!ambush)
			PlaySoundEffect( defender, attackerweaponType.hitSound ); // ambush hit sound done in hitscript.inc
		endif
	endif
else
	if (attacker.weapon.attribute == ATTRIBUTEID_ARCHERY)
		if (ambush)
       			PrintTextAbove(attacker, "*Failed Ambush!*", 3, 33);
      		endif
		PlaySoundEffect( attacker, attackerweaponType.projectileSound );
		return;
	else
		PlaySoundEffect( attacker, attackerweaponType.misssound);
		return;
	endif
endif


var hitscript := attacker.weapon.hitscript;

if (!hitscript)
	Broadcast("cant fint it!");
	return;
endif

var wbasedamage:= RandomDiceRoll( attackerweaponType.damage ); 
if (attacker.weapon.dmg_mod)
	wbasedamage := wbasedamage + attacker.weapon.dmg_mod;
endif
 //further bonus damage based on weapon skill - temporarily removed pending testing
	// changed for the players level
	
	//  damage is set to 0 in hitscript to rewrite damage amounts anyway...
	//var dambonus := 1 + (attackerlevelmod/130); //i.e. at 130 theyd do 2x times base... 
	//wbasedamage := CInt(wbasedamage * dambonus);

	//find random piece of armor to hit -- need this for onhit script
	var wornarmor := array;
	foreach li in ListEquippedItems(defender)
		if (li.isA(POLCLASS_ARMOR) && GetObjProperty(li, "OnHitScript"))
			wornarmor.append(li);
		endif
	endforeach
	var def_armor;
	if (len(wornarmor)>0)
		def_armor:=wornarmor[RandomInt(len(wornarmor))+1];
	endif

	start_script (":combat:"+hitscript, {attacker, defender, attacker.weapon, def_armor, wbasedamage, 0});
endfunction


function PlayArcheryAnimation(attacker, defender, attackerweaponType, ambush)


var animation := attackerweaponType.ProjectileAnim;
var color := 0;

if (ambush) 
	color := 1305;
endif

// Cains crossbow special!
if (GetObjProperty(attacker.weapon, "#Activated") && attacker.weapon.objtype == 0xda15)
	color := 1304;
	animation := 0x183e;
endif

PlayMovingEffectXYZEx( attacker.x, attacker.y, attacker.z+9, defender.x, defender.y, defender.z+5,  defender.realm, animation, 2, 0, color);

endfunction


function CheckHitChance(attacker, defender, attackerlevelmod)

	var hc := 50.0;
	
	if (attacker.weapon.attribute == ATTRIBUTEID_ARCHERY)
		hc := hc - 10.0;
	endif

	
	// since chance is based on both classes current weapon skill, we need this here incase its a mage fighting a mage with maces. otherwise both will be hit
	// wayyyyy too much.
	var defclass := GetClass(defender);
	var defwepattribute := GetAttribute( defender, defender.weapon.attribute);
	if (defclass)
		if (defender.weapon.graphic in ClassWeapons(defclass))
			defwepattribute :=  GetClasseSkillTotal(defender, GetClass(defender));
			// since mages/thiefs can subclass. incorporate extra skills into chance.... 
			
				defwepattribute:= CDbl(defwepattribute/8.0);
			
		endif
	endif

		// rather simple formular determining hit chance. based on defenders weapon skill and attackers. guess it makes sense
	// i mean what else can effect hit chance? maybe i can plug in luck here!@!@???
	var hit_chance := (attackerlevelmod + 50.0) / (2.0 * defwepattribute + hc);
	// was gonna give a bonus on level too, but maybe thats unfair for the default combat system
	// since that doesnt give hit chance bonus on level?  it can be tweaked later...
	//hit_chance := hit_chance * (CDbl(GetClasseLevel(attacker)/100.0)+1.0);
	
	var chance := RandomFloat(1.0);
	if( chance < hit_chance )
		return 1;
	else 
		return 0;
	endif
	
endfunction


//////////////////------------------------------------------ ARCHERY HOOK ------------------------------------------\\\\\\\\\\\\\\\\\

function ArcheryAttack(attacker, defender)


var weaponType := cfg[attacker.weapon.objtype];

if (!checkForAndDecrementAmmunition( attacker, weaponType))	
	return;
endif

if (! ValidArcheryWeapon(weaponType))
	return;
endif

var archery := GetEffectiveSkill(attacker, SKILLID_ARCHERY);

PlayArcheryAnimation(attacker, defender, weaponType, 0);


PerformAction( attacker, weaponType.Anim);
sleepms((100-weaponType.Speed)/10);

AwardSkillPoints( attacker, GetSkillIdByAttributeId( attacker.weapon.attribute ), 20 );

if (CheckArcheryHitChance(attacker, defender, archery))

        PlaySoundEffect( defender, weaponType.hitSound );

else
	PlaySoundEffect( attacker, weaponType.projectileSound );
	return;
endif

var hitscript := attacker.weapon.hitscript;
//Broadcast("hitscript: " + hitscript);
if (!hitscript)
	//Broadcast("cant fint it!");
	return;
endif

var wbasedamage:= RandomDiceRoll( weaponType.damage ); 

if (attacker.weapon.dmg_mod)
	wbasedamage := wbasedamage + attacker.weapon.dmg_mod;
endif

var dmgmult := archery + 50.0;
dmgmult := dmgmult + GetStrength(attacker)*0.2;
dmgmult := dmgmult * 0.01;

wbasedamage := wbasedamage * dmgmult;


//find random piece of armor to hit -- need this for onhit script
var wornarmor := array;
foreach li in ListEquippedItems(defender)
	if (li.isA(POLCLASS_ARMOR) && GetObjProperty(li, "OnHitScript"))
		wornarmor.append(li);
	endif
endforeach

var def_armor;
if (len(wornarmor)>0)
	def_armor:=wornarmor[RandomInt(len(wornarmor))+1];
endif

start_script (":combat:"+hitscript, {attacker, defender, attacker.weapon, def_armor, CInt(wbasedamage), 0});

endfunction


function CheckArcheryHitChance(attacker, defender, skill)


var hit_chance := (CDbl(skill) + 50.0) / (2.0 * GetEffectiveSkill(defender, GetSkillIdByAttributeId( defender.weapon.Attribute )) + 40.0);

var chance := RandomFloat(1.0);
if( chance < hit_chance )
	return 1;
else 
	return 0;
endif
	
endfunction

function ValidArcheryWeapon(weaponType)
//returns true if itemdesc elem contains the miniumum requires props for processing
	if (!weaponType.ProjectileAnim || !weaponType.Anim || !weaponType.hitSound || !weaponType.projectileSound ||
	!weaponType.hitscript || !weaponType.damage || !weaponType.Projectile || !weaponType.ProjectileType )
		return 0;
	endif
	return 1;
endfunction


function checkForAndDecrementAmmunition( who, weaponType )
	var mypack := EnumerateItemsInContainer( who.backpack );
	var expotions := {0xdc08, 0xdc09, 0xdc07, 0xff2f, 0xff30, 0xff31, 0xff32, 0xff33, 0xff34, 0xff35, 0xff36};
	foreach item in mypack
		if( item.objtype == weaponType.ProjectileType )
			if (SubtractAmount( item, weaponType.Projectile))
				return 1;
			endif
		elseif ( weaponType.ProjectileType == 1 && item.objtype in expotions)
			var type := item.objtype;
			if (SubtractAmount( item, weaponType.Projectile))
				SetObjProperty(who, "#LastExplosionShot", type);
				return 1;
			endif

		endif
	endforeach
	return 0;
endfunction