// HitScript Include

use uo;
use attributes;

include "include/client";
include "include/dotempmods";
include "include/classes";
include "include/damages";
include "include/bitwise";
include "include/random";
include "include/attributes";

var ADDPIERCINGEFFECT := 0;

function RecalcDmg( attacker, defender, weapon, armor, byref basedamage, piercing := 0 )

	if( !GetObjProperty( weapon, "Astral" ) )
		return RecalcPhysicalDmg( attacker , defender , weapon , armor , basedamage , piercing );
	else
		return RecalcAstralDmg( attacker , defender , weapon , armor , basedamage , piercing );
	endif

endfunction


function RecalcPhysicalDmg( attacker, defender, weapon, armor, byref basedamage, piercing := 0 )


	var rawdamage;
	var absorbed;
	var ar := CInt(armor.ar) + CInt(defender.ar_mod);
	var anatomy := GetEffectiveSkill( attacker , SKILLID_ANATOMY );
	var archery := GetEffectiveSkill( attacker , SKILLID_ARCHERY );

	if( defender.isa(POLCLASS_NPC) )
		if( !attacker.isa(POLCLASS_NPC))
			basedamage := basedamage * 1.5;
		endif
	endif

	if (weapon.graphic in ClassWeapons(GetClass(attacker)))

		basedamage := SpecialClassWeaponHit(attacker, defender, weapon, basedamage);
		
	else // normal basedamage stuff
		basedamage := ModByDistance( attacker, defender, weapon, basedamage );

		if (weapon.attribute == ATTRIBUTEID_ARCHERY)
			basedamage := basedamage * ( 1 + archery * 0.002 );
		else
			basedamage := basedamage * ( 1 + anatomy * 0.002 );
		endif
	endif

	if( !piercing )
		rawdamage := GetShieldAbsorption( attacker , defender , weapon , basedamage );
		absorbed  := ar * (Random(51) + 50) * 0.01;
	else
		rawdamage := basedamage;
		absorbed  := 0;
	endif

	rawdamage := rawdamage - absorbed;
	rawdamage := rawdamage * 0.5;
	rawdamage := ModByProt( defender , rawdamage );

	if( rawdamage < 0 )
		rawdamage := 0;
	endif

	MaceHit( attacker , defender , weapon , armor , absorbed );

	return CInt( rawdamage );

endfunction


function RecalcAstralDmg( attacker, defender, weapon, armor, byref basedamage, piercing := 0 )

	var rawdamage;
	var absorbed := 0;

	var ar := CInt( GetObjProperty( armor , "Astral" ) ) * 25 * CInt( armor.ar );

	basedamage := basedamage
		* ((GetEffectiveSkill( attacker , SKILLID_SPIRITSPEAK ) + 50.0 + (GetIntelligence(attacker) * 0.2)) * 0.01)
		/ ((GetEffectiveSkill( attacker , SKILLID_TACTICS ) + 50.0 + (GetStrength(attacker) * 0.2)) * 0.01);

	AwardRawSkillPoints( attacker, SKILLID_EVALINT, 30 );
	AwardRawSkillPoints( attacker, SKILLID_SPIRITSPEAK, 30 );

	if( defender.isa(POLCLASS_NPC) )
		basedamage := basedamage * ClasseBonus( attacker , CLASSEID_MAGE );
	else
		var level := GetObjProperty( attacker , CLASSEID_MAGE );
		if( level )
			level := level - 2;
			if( level >= 1 )
				basedamage := basedamage * ClasseBonusByLevel( level );
			endif
		endif
	endif

	if( GetObjProperty( attacker , CLASSEID_WARRIOR ) )
		if( !GetObjProperty( attacker , CLASSEID_MAGE ) )
			basedamage := basedamage / ClasseBonus( attacker , CLASSEID_WARRIOR );
		endif
	endif

	if( GetObjProperty( defender , CLASSEID_WARRIOR ) )
		if( !GetObjProperty( defender , CLASSEID_MAGE ) )
			basedamage := basedamage * ClasseBonus( defender , CLASSEID_WARRIOR );
		endif
	endif

	basedamage := basedamage * ( 1 + GetEffectiveSkill( attacker , SKILLID_EVALINT ) * 0.002 );
	rawdamage  := basedamage;

	if( !piercing )

		var meditation := GetEffectiveSkill( defender , SKILLID_MEDITATION );
		meditation := meditation * ClasseBonus( defender , CLASSEID_MAGE );

		if( (Random(100) + 1) <= CInt( meditation * 0.5 ) )

			var resist := GetEffectiveSkill( defender , SKILLID_MAGICRESISTANCE );
			var defint := GetIntelligence(defender);

			AwardRawSkillPoints( defender, SKILLID_MEDITATION, 30 );
			AwardRawSkillPoints( defender, SKILLID_MAGICRESISTANCE, 30 );
			PerformAction(  defender, ANIM_CAST_AREA );
			SendSysmessage( defender, "You successfully block a part of the astral attack." );

			if( GetObjProperty( defender, CLASSEID_MAGE ) )
				rawdamage := rawdamage - (resist + defint) * 0.25 * ClasseBonus( defender , CLASSEID_MAGE );
			elseif( GetObjProperty( defender, CLASSEID_WARRIOR ) )
				rawdamage := rawdamage - (resist + defint) * 0.25 / ClasseBonus( defender , CLASSEID_WARRIOR );
			endif

			if( rawdamage < 0 )
				rawdamage := 0;
			endif

		endif

		if( ar )
			absorbed := CInt( ar * (Random(51) + 50) / 100 );
		endif

	endif

	rawdamage := rawdamage - absorbed;
	rawdamage := rawdamage * 0.5;
	if( rawdamage < 0 )
		rawdamage := 0;
	endif

	return CInt(rawdamage);

endfunction


function ModByDistance( attacker, defender, weapon, basedamage )

	if( weapon.attribute == ATTRIBUTEID_ARCHERY )

		var rlevel := CInt(GetObjProperty( attacker, CLASSEID_RANGER ));
		
		if (defender.isa(POLCLASS_NPC))
			basedamage:= basedamage * ClasseBonus (attacker, CLASSEID_RANGER);
		else
			basedamage:= basedamage * ClasseSmallBonusByLevel( GetObjProperty(attacker, CLASSEID_RANGER) );
		endif

		var dist := Distance( attacker, defender );
		if( (dist <= 1) || (dist > 10 + (rlevel*RANGER_LEVEL_ARCHERY_RANGE_BONUS)) ) // a bit more long rang for rangers
			basedamage := basedamage * 0.25;
		endif

	else

		
		if (defender.isa(POLCLASS_NPC))
			basedamage:= basedamage * ClasseBonus (attacker, CLASSEID_WARRIOR);
		else
			basedamage:= basedamage * ClasseSmallBonusByLevel( GetObjProperty(attacker, CLASSEID_WARRIOR) );
		endif

	endif

	if( GetObjProperty( attacker , CLASSEID_MAGE ) )
		if( !GetObjProperty( attacker , CLASSEID_WARRIOR ) )
			basedamage := basedamage / ClasseBonus( attacker , CLASSEID_MAGE );
		endif
	endif

	if( GetObjProperty( defender , CLASSEID_MAGE ) )
		if( !GetObjProperty( defender , CLASSEID_WARRIOR ) )
			basedamage := basedamage * ClasseBonus( defender , CLASSEID_MAGE );
		endif
	endif

	return basedamage;

endfunction


function MaceHit( attacker, defender, weapon, armor, absorbed )

	var archance := 2;
	var weapchance := 2;

	if( weapon.attribute == ATTRIBUTEID_MACEFIGHTING )

		var loss := Random(2) + 1;
		if(loss > GetStamina(defender) )
			SetStamina(defender, 0);
		else
			SetStamina(defender, GetStamina(defender)-loss);
		endif

		if( armor.hp )
			if( Random(100) < 5 )
				armor.hp := armor.hp - 1;
			endif
		endif

	elseif( Random(100) < archance )

		if( armor.hp )
			armor.hp := armor.hp - 1;
		endif

	endif

	if( Random(100) < weapchance )
		if( weapon.hp )
			weapon.hp := weapon.hp - 1;
		endif
	endif

	if( armor.quality )
		if( (armor.hp > armor.maxhp) or (armor.hp < 1) )
			DestroyEquipment( defender, armor );
		endif
	endif

	if( weapon.quality )
		if( (weapon.hp > weapon.maxhp) or (weapon.hp < 1) )
			DestroyEquipment( attacker , weapon );
		endif
	endif

endfunction


function ModByProt( defender, basedamage )

	var physicalprot := GetObjProperty( defender , "PhysicalProtection" );
	if( !physicalprot )
		return basedamage;
	else
		basedamage := basedamage * ( 1 - physicalprot * 0.05 );
		return basedamage;
	endif

endfunction


function GetShieldAbsorption( attacker, defender, weapon, basedamage )

	var shield := GetEquipmentByLayer( defender , LAYER_HAND2 );
	var shieldar := CInt(shield.ar);
	if( shieldar )
		var parry_skill := GetEffectiveSkill( defender , SKILLID_BATTLE_DEFENSE );
		parry_skill := CInt( parry_skill * ClasseBonus( attacker , CLASSEID_WARRIOR ) );

		if( (Random(100) + 1) <= CInt(parry_skill / 2) )
			var absorbed;

			PerformAction( defender , ANIM_ATTACK_XBOW );

			if( weapon.attribute == ATTRIBUTEID_ARCHERY )
				absorbed := shieldar;
			else
				absorbed := CInt(shieldar / 2);
			endif

			basedamage := basedamage - absorbed;
			if( basedamage < 0 )
				basedamage := 0;
			endif

			MaceHit( attacker , defender , weapon , shield , absorbed );
		endif
	endif

	return basedamage;

endfunction


function DealDamage( attacker, defender, weapon, armor, basedamage, rawdamage )

	if( !GetObjProperty( weapon, "Astral" ) )

		var poisoned := GetObjProperty( weapon   , "SkillPoisoned" );
		var reactive := GetObjProperty( defender , "ReactiveArmor" );
		var onhit    := GetObjProperty( armor    , "OnHitScript" );

		//Check if the item was poisonned by someone
		if( poisoned )

			var plvl := CInt( poisoned / 3 );
			poisoned  := poisoned - 1;
			if( poisoned )
				SetObjProperty( weapon , "SkillPoisoned" , poisoned );
			else
				EraseObjProperty( weapon , "SkillPoisoned" );
			endif

			SetPoison( defender, plvl, "You have been poisoned by " + attacker.name + "." );

		endif

		var class:=GetClass(defender);		
		var level:=GetClasseLevel(defender);
		

		if (level < 0)
			level:=0;
		endif

		if( attacker.isA(POLCLASS_NPC) )
			case (class)
				CLASSEID_WARRIOR:	rawdamage := CInt( rawdamage / ClasseBonus( defender, CLASSEID_WARRIOR ));
			endcase
		else
			case (class)
				CLASSEID_WARRIOR:	rawdamage := CInt( rawdamage / ClasseSmallBonusByLevel( level ));
							basedamage := CInt( basedamage * ClasseSmallBonusByLevel( level ) ); //reactive armour more damage
			endcase
		endif

/*   - old formula

		if( GetObjProperty( defender , CLASSEID_WARRIOR ) )
			if( attacker.isa(POLCLASS_NPC))
				rawdamage := CInt( rawdamage / ClasseBonus( defender , CLASSEID_WARRIOR ) );
			else
				var level := GetObjProperty( defender , CLASSEID_WARRIOR );
				if( level )
					level := level - 1;
					if( level >= 1 )
						basedamage := CInt( basedamage * ClasseBonusByLevel( level ) ); // the damage for reactive armour...
					endif
				endif
			endif
		endif
*/
		//Check if reactive armor spell is on
		if( reactive )
			start_script( ":combat:reactivearmoronhit" , { attacker, defender, basedamage, rawdamage, reactive} );
		endif

		//Check if the armor have an on hit script and launch it
		if( onhit )
			start_script( onhit , {attacker, defender, weapon, armor, basedamage, rawdamage} );
		else
			ApplyTheDamage( defender , attacker , rawdamage );
		endif

	else

		ApplyTheAstralDamage( defender , attacker , rawdamage );

	endif

endfunction


function DestroyEquipment( who, item )

	// Wrestling, core error 
	if (item.objtype == 0xF020)
		return 0;
	endif

	var cursed := GetObjProperty( item , "Cursed" );

	if( cursed )
		SetObjProperty( item , "Cursed" , 3 );
	endif

	if( who.backpack )
		MoveItemToContainer( item , who.backpack );
	endif

	if( who.isa(POLCLASS_NPC) )
		if( item.attribute )
			PrintTextAbove( who , who.name + " seem exhausted and can barely hit anyones anymore!" );
		else
			PrintTextAbove( who , who.name + "'s defences has been penetrated making it easy to hit vital parts!" );
		endif
	endif

	DestroyItem( item );

endfunction

//////////////////////////////////////////////////////////////////////////////////////////////
//
// SpecialClassWeaponHit()
//
// Function used to determine damage by classes using their special weapons that don't have combat skills
// ie, mages with staffs, bards with crooks, thiefs with daggers and balanced
// Damage is based on total class skills and their level
//
/////////////////////////////////////////////////////////////////////////////////////////////
function SpecialClassWeaponHit(attacker, defender, weapon, basedamage)

basedamage := 0;
var item_cfg := ReadConfigFile( ":combat:itemdesc" );
var damage := item_cfg[weapon.objtype].Damage;
var dmgmod := weapon.dmg_mod;

damage := RandomDiceRoll(damage) + dmgmod;
	
var attackerskill := GetClasseSkillTotal(attacker, GetClass(attacker));

attackerskill  := CDbl(attackerskill /8.0);


basedamage := attackerskill + 50.0;
basedamage := basedamage + (GetStrength(attacker) * 0.20); // .05 damage boost
basedamage := basedamage * 0.01;
basedamage := basedamage * damage;

// An extra 5% damage bonus for these guys - thief and pp archery damage were too similiar
basedamage := basedamage * 1.05;

var parry_chance := GetEffectiveSkill( defender, SKILLID_PARRY ) / 200.0;

if( RandomFloat(1.0)  < parry_chance ) // less than == <
	var shield := GetEquipmentByLayer( defender, LAYER_HAND2 );
	var shieldar := CInt(shield.ar);
      	basedamage := basedamage - CInt(shieldar);
endif

// Distance check for bows, if they are further away than 8 spaces, damage penalty...
var dist := Distance( attacker, defender );
if ((dist <= 1 || dist > 10) && weapon.attribute == ATTRIBUTEID_ARCHERY) 
	basedamage := basedamage * 0.01;

// now throwing daggers, penatly if over 7 tiles away
elseif (dist > 7 && weapon.attribute == ATTRIBUTEID_FENCING)
	basedamage := basedamage * 0.1;
endif

if( defender.isA(POLCLASS_NPC) )
	if( !attacker.npctemplate )
		basedamage := basedamage * 1.5;
	endif
endif
//=========== mages deal less damage and receive more when others and them use the weps ===============\\
// should mages really deal less damage? we'll see and maybe remove that one, but they should take more.....

if( GetObjProperty( attacker , CLASSEID_MAGE ) )
	if( !GetObjProperty( attacker , CLASSEID_WARRIOR ) ) //as below????
		basedamage := basedamage / ClasseBonus( attacker , CLASSEID_MAGE );
	endif
endif

if( GetObjProperty( defender , CLASSEID_MAGE ) )
	if( !GetObjProperty( defender , CLASSEID_WARRIOR ) ) //wtf? hes a mage so WONT be a warrior?
		basedamage := basedamage * ClasseBonus( defender , CLASSEID_MAGE );
	endif
endif
//---------------------------------------------------------------------------------------

//================================= class bonus damage =================================\\
	
// damage bonus/ambush checking for thiefs
if (IsThief(attacker))
	//Print("before ambush "+basedamage);
	basedamage := ApplyAmbushDamage(attacker, defender, basedamage);
	//Print("after ambush "+basedamage);
endif

basedamage := basedamage * ( 1 + attackerskill * 0.002 );

return basedamage;

// don't need to check if defender is warrior for protecion bonus, thats done in dealdamage

endfunction


function ApplyAmbushDamage(attacker, defender, basedamage)

	var timeambush := GetObjProperty(attacker, "attackInitiatedWhileHidden");
	//Broadcast(timeambush + " " + ReadGameClock());
	if (!timeambush || timeambush ==error)
		return basedamage;
	endif	
	if (timeambush>(ReadGameClock()-4))
		PrintTextAbove(attacker, "*Ambush!* " ,3,38);
		
		if (GetObjProperty(attacker, "#DaggerThrow")) // it was a thrown dagger, play diff sound
			PlaySoundEffect(defender, 0x140); 
			EraseObjProperty(attacker, "#DaggerThrow");
		elseif (attacker.weapon.attribute != "Archery") // archery sound effect done in zhpstuff.inc
			PlaySoundEffect(defender, 0x388);
		endif
		
		EraseObjProperty(attacker, "attackInitiatedWhileHidden");
		ADDPIERCINGEFFECT := 1;

		basedamage := basedamage * (1.0 + CDbl(GetClasseLevel(attacker)*THIEF_AMBUSH_BONUS_DAMAGE)/100.0);

		return (basedamage * (1.0 + CDbl(BackStabDamageBonus(GetClasselevel(attacker), attacker, defender)/100.0)));
	endif
			
	return basedamage;
endfunction

//////////////////////////////////////////////////////////////////////////////////
//
// BackstackDamageBonus()
//
//  rewritten backstab check. backstabs no matter which way the attacker faces, only the
//  whether victim has back to attacker.
//
// The backstab radious is much like a cone, ie
//
// defender ----->  						  0
//							         ---
// area attacker must be in to backstab   ---->	                ----- 	
//							       -------
//////////////////////////////////////////////////////////////////////////////////

function BackStabDamageBonus(thieflevel, attacker, defender)
	var backstab:=0;

	// must be level 2 to do backstab with ambush
	if (thieflevel < 2)
		return 0;
	endif
	
	var targetfacing := defender.facing;
	
	case (targetfacing)
	
	7: // north west, UP
		if (IsInBox( attacker, defender.x, defender.x+15, defender.y, defender.y+15 ))
			backstab := 1;
		endif
		
	1: // north east, right - this is correct
		if (IsInBox( attacker, defender.x, defender.x-15, defender.y, defender.y-15 ))
			backstab := 1;
		endif
	3: // south east, down
		if (IsInBox( attacker, defender.x, defender.x-15, defender.y, defender.y-15 ))
			backstab := 1;
		endif
	5: // south west left
		if (IsInBox( attacker, defender.x, defender.x+15, defender.y-15, defender.y ))
			backstab := 1;
		endif
		
	// we cant use inbox for north, east, south, west.... 
		
	2: // east, diagnal right down 
		if (attacker.x < defender.x) // attacker is ANYWHERE behind target
			var xdistance := defender.x -attacker.x;
			if (xdistance < 15) // player is less than 15 tiles away
				if (attacker.y == defender.y) // attacker is on same y axis, (straight behind)
						backstab := 1;
						
				else // attacker is not directly behind
					var i;
					for (i := 1; i < 16; i := i + 1)
						if (attacker.y == defender.y+i)
							if ((xdistance - i) >= 0 )
								backstab := 1;
								break;
							endif
				
						elseif (attacker.y == defender.y-i) 
							if ((xdistance - i) >= 0 )
								backstab := 1;
								break;
							endif
						endif
					endfor
				endif
			endif
		endif
		
	4: // south, diagnal left down 
		if (attacker.y < defender.y) // attacker is ANYWHERE behind target
			var ydistance := defender.y - attacker.y;
			if (ydistance < 15) // player is less than 15 tiles away
				if (attacker.x == defender.x) // attacker is on same x axis, (straight behind)
						backstab := 1;
			  
				else // attacker is not directly behind
					var i;
					for (i := 1; i < 16; i := i + 1)
						if (attacker.x == defender.x+i) 
							if ((ydistance - i) >= 0 )
								backstab := 1;
								break;
							endif
				
						elseif (attacker.x == defender.x-i) 
							if ((ydistance - i) >= 0 )
								backstab := 1;
								break;
							endif
						endif
					endfor
				endif
			endif
		endif
			
	6: // west diagnal left up
		if (attacker.x > defender.x) // attacker is ANYWHERE behind target
			var xdistance := attacker.x - defender.x;
			if (xdistance < 15) // player is less than 15 tiles away
				if (attacker.y == defender.y) // attacker is on same y axis, (straight behind)
						backstab := 1;
						
				else // attacker is not directly behind
					var i;
					for (i := 1; i < 16; i := i + 1)
						if (attacker.y == defender.y+i) // player is i tile/s south of player, any distance away
							if ((xdistance - i) >= 0 )
								backstab := 1;
								break;
							endif
				
						elseif (attacker.y == defender.y-i) // player is i tile/s north of player
							if ((xdistance - i) >= 0 )
								backstab := 1;
								break;
							endif
						endif
					endfor
				endif
			endif
		endif
		
	0: // north, diagnal right up 
		if (attacker.y > defender.y) // attacker is ANYWHERE behind target
			var ydistance := attacker.y - defender.y;
			if (ydistance < 15) // player is less than 15 tiles away
				if (attacker.x == defender.x) // attacker is on same x axis, (straight behind)
						backstab := 1;
			  
				else // attacker is not directly behind
					var i;
					for (i := 1; i < 16; i := i + 1)
						if (attacker.x == defender.x+i) 
							if ((ydistance - i) >= 0 )
								backstab := 1;
								break;
							endif
				
						elseif (attacker.x == defender.x-i) 
							if ((ydistance - i) >= 0 )
								backstab := 1;
								break;
							endif
						endif
					endfor
				endif
			endif
		endif
          
	endcase
		
	
	if (backstab)
		
	//	PrintTextAbove(defender, "*Backstab!*",3,38);
		SendSysMessage(attacker, "Your blow hits "+defender.name+" painfully in the back!", 3, 38);
	
	//	PlaySoundEffect(defender, 0x01cb);
		return thieflevel * THIEF_BACKSTAB_BONUS_DAMAGE;
		
	endif
	return 0;
endfunction